/*************************************************************17.04.2003*/
/* ipl_peval: evaluation of the periodic spline function defined by	*/
/*	      ipl_pspline						*/
/************************************************************************/
/* xvalue	(i)  abszissa value
   x[n], y[n]	(i)  abszissa and ordinate arrays
   b, c, d[n]	(i)  coefficient arrays generated by ipl_spline()	*/
/*======================================================================*/
#include <math.h>
#include <mathc.h>

double ipl_peval(double xvalue, int n, double *x, double *y, double *b,
double *c, double *d) {
  int i, high, low;
  double xx, yvalue, period;

  if (xvalue < x[0] || xvalue > x[n-1]) {
    period = x[n-1] - x[0];
    i = (xvalue - x[0])/period;
    xvalue -= i * period;
  }
  low = 0;				/* locate interval by bisection */
  high = n - 1;
  while (high - low > 1) {
    i = (low + high)/2;
    if (xvalue >= x[i]) low = i;
    else high = i;
  }
  xx = xvalue - x[low];
  yvalue = ((d[low] * xx + c[low]) * xx + b[low]) * xx + y[low];
  return (yvalue);
}
