/*************************************************************16.12.2001*/
/* Test subroutine diff_2all.c (2-dimensional differentiation)		*/
/************************************************************************/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. x, y, increment, r (degree of extrapolation, 0 <= r <= 2)

   result: derivatives of exp(x) * exp(y)

   link with -lmathc -lm						*/
/*======================================================================*/
#include <stdio.h>
#include <math.h>
#include <mathc.h>

static double f(double x, double y, void *s);


int main(void) {
  int i, r;
  double x, y, dx, dy, dinc, d[15];

  scanf("%lf%lf%lf%d", &x, &y, &dinc, &r);
  dx = x * dinc;
  dy = y * dinc;
  if ((i = diff_2all(f, x, y, NULL, 4, r, dx, dy, d)) != 0) {
    printf("error %d\n");
    return(1);
  }
  
  for (i = 0; i < 15; i++) printf("%20.12e\n", d[i]);
  printf("\n%20.12e\n", exp(x+y));
  return(0);
}

static double f(double x, double y, void *s) {
  return(exp(x + y));
}
