/*************************************************************02.01.2003*/
/* Test the subroutine diff_romberg.c (1-dimensional differentiation)		*/
/************************************************************************/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. x, increment, xmin, xmax, r (degree of extrapolation)

   result: derivatives of exp(x)

   link with -lmathc -lm						*/
/*======================================================================*/
#include <stdio.h>
#include <math.h>
#include <mathc.h>

static double f(double x, void *s);
int diff_romberg(double (*f)(), void *aux, int n, double x, double h,
int maxord, double xmin, double xmax, double *fd);

int main(void) {
  int i, r;
  double x, dx, xmin, xmax, d;

  scanf("%lf%lf%lf%lf%d", &x, &dx, &xmin, &xmax, &r);
  if ((i = diff_romberg(f, NULL, 1, x, dx, r, xmin, xmax, &d)) != 0) {
    printf("error %d\n");
    return(1);
  }
  
  printf("%20.12e %20.12e\n", d, exp(x));
  return(0);
}

static double f(double x, void *s) {
  return(exp(x));
}
