/**********************************************************************/
/* Test integration subroutine int_simpson			      */
/* (calculation of Integral(exp(x) dx))				      */
/**********************************************************************/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. Enter integration limits a and b, and the number of panels

   link with -lmathc -lm!					      */
/*====================================================================*/
#include <stdio.h>
#include <math.h>
#include <mathc.h>

double function(double x, void *u);

int main(void) {
  int i;
  double a, b, q, qex;

  scanf("%lf%lf%d", &a, &b, &i);
  q = int_simpson(function, NULL, a, b, i);
  qex = exp(b) - exp(a);
  printf("int_simpson: %lf   exact: %lf\n", q, qex);
  return (0);
}

/**********************************************************************/
/* Integrand function: exp(x)					      */
/**********************************************************************/
/* x		   (i)	argument
   RESULT	   (o)  exp(x)					      */
/*====================================================================*/
double function(double x, void *u) {
  return (exp(x));
}
