/*************************************************************02.01.2003*/
/* Test the subroutine ipl_lagrange.c (Lagrange interpolation		*/
/*									*/
/************************************************************************/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. number of points (max. 10)
   2. as many (x,y) pairs

   result: coefficients of Lagrange polynomial

   link with -lmathc -lm						*/
/*======================================================================*/
#include <stdio.h>
#include <math.h>
#include <mathc.h>

#define NMX			10

int ipl_lagrange(int n, double *x, double *y, double *a);

int main(void) {
  int i, n;
  double x[NMX], y[NMX], a[NMX];

  scanf("%d", &n);
  for (i = 0; i < n; i++) scanf("%lf%lf", &x[i], &y[i]);
  if ((i = ipl_lagrange(n, x, y, a)) != 0) {
    printf("error %d\n", i);
    return(1);
  }
  
  for (i = 0; i < n; i++) printf("%3d %e\n", i, a[i]);
  return(0);
}

static double f(double x, void *s) {
  return(exp(x));
}
