/**********************************************************************/
/* Test spline subroutine (or akima)				      */
/**********************************************************************/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. number of data pairs
   2. as many pairs (with increasing x-values)

   link with -lmathc						      */
/*====================================================================*/
#include <stdio.h>
#include <math.h>
#include <mathc.h>

#define NMAX		32

int main(void) {
  int i, n;
  double h, xarg, yarg, x[NMAX], y[NMAX], b[NMAX], c[NMAX], d[NMAX];

  scanf("%d", &n);
  for (i = 0; i < n; i++) scanf("%lf%lf", &x[i], &y[i]);
  i = ipl_spline(n, x, y, b, c, d);
  printf("error code: %d\n\n", i);
  if (i > 0) return(i);
  for (i = 0; i < n; i++) printf("%2d %f %f %f %f %f\n", i, x[i],
  y[i], b[i], c[i], d[i]);
  printf("\n");
  h = (x[n-1] - x[0]) * 0.1;
  for (xarg = x[0]; xarg <= x[n-1]; xarg +=h) {
    yarg = ipl_eval(xarg, n, x, y, b, c, d);
    printf("%f %f\n", xarg, yarg);
  }
}
